//
//  MyDataSource.m
//  Tables


#import "MyDataSource.h"

@implementation MyDataSource

- (id)init {
    items = [[NSMutableArray alloc] init];
    [items addObject:[NSString stringWithString:@"Very first object"]];
    [items addObject:[NSString stringWithString:@"Another object"]];
    [items addObject:[NSString stringWithString:@"Enough objects for now"]];
    
    return self;
}

- (void)addItem:(id)item {
    NSLog(@"addItem: %@", item);
    [items addObject:item];

}

- (void)removeItemAt:(int)index {
    NSLog(@"removeItem: %d", index);
    [items removeObjectAtIndex:index];
}

- (id)getItemAtColumn:(NSInteger)col
                    row:(NSInteger)row {
    return [items objectAtIndex:row];
}

- (NSInteger)numberOfRowsInTableView:(NSTableView *)tableView {
    return [items count];
}

- (id)tableView:(NSTableView *)tableView 
objectValueForTableColumn:(NSTableColumn *)tableColumn
            row:(int)row {
    return [items objectAtIndex:row];
}

- (void)tableView:(NSTableView *)tableView
   setObjectValue:(id)object
   forTableColumn:(NSTableColumn *)tableColumn
              row:(int)row {
    [items addObject:object];
}

- (void)dealloc {
    [items release];
    [super dealloc];
}

@end
